<?php
/**
 * shortcode: Custom Post Types
 *
 *
 * @package escwp
 */
class escwp_shortcode_Post_Types {
	
	public function __construct()
	{
		$this->register_post_type();
	}

	public function register_post_type()
	{
		$args = array();	

		// shortcode
		$args['post-type-shortcode'] = array(
			'labels' => array(
				'name' => __( 'Shortcode', 'escwp' ),
				'singular_name' => __( 'Item', 'escwp' ),
				'add_new' => __( 'Create New Shortcode', 'escwp' ),
				'add_new_item' => __( 'Add New Shortcode', 'escwp' ),
				'edit_item' => __( 'Edit Shortcode', 'escwp' ),
				'new_item' => __( 'New Item', 'escwp' ),
				'view_item' => __( 'View Item', 'escwp' ),
				'search_items' => __( 'Search Through shortcode', 'escwp' ),
				'not_found' => __( 'No items found', 'escwp' ),
				'not_found_in_trash' => __( 'No items found in Trash', 'escwp' ),
				'parent_item_colon' => __( 'Parent Item:', 'escwp' ),
				'menu_name' => __( 'Easy Shortcode Creator', 'escwp' ),				
			),		  
			'hierarchical' => false,
	        'description' => __( 'Add a Shortcode Item', 'escwp' ),
	        'supports' => array( 'title', 'editor', 'thumbnail'),
	        'menu_icon' =>  'dashicons-images-alt',
	        'public' => true,
	        'publicly_queryable' => true,
	        'exclude_from_search' => false,
	        'query_var' => true,
	        'rewrite' => true,
	        // This is where we add taxonomies to our CPT
        	//'taxonomies'          => array( 'category' ),
		);	

		// Register post type: name, arguments
		register_post_type('escwp-shortcode', $args['post-type-shortcode']);
	}
}

function escwp_shortcode_types() { new escwp_shortcode_Post_Types(); }

add_action( 'init', 'escwp_shortcode_types' );

/*-----------------------------------------------------------------------------------*/
/*	Creating Custom Taxonomy 
/*-----------------------------------------------------------------------------------*/
// hook into the init action and call create_book_taxonomies when it fires
//add_action( 'init', 'create_shortcode_taxonomies', 0 );

// create two taxonomies, genres and writers for the post type "book"
/*function create_shortcode_taxonomies() {
	// Add new taxonomy, make it hierarchical (like categories)
	$labels = array(
		'name'              => _x( 'Shortcode Categories', 'taxonomy general name', 'escwp' ),
		'singular_name'     => _x( 'Category', 'taxonomy singular name', 'escwp' ),
		'search_items'      => __( 'Search Shortcode Categories', 'escwp' ),
		'all_items'         => __( 'All Shortcode Categories', 'escwp' ),
		'parent_item'       => __( 'Parent Shortcode Category', 'escwp' ),
		'parent_item_colon' => __( 'Parent Shortcode Category:', 'escwp' ),
		'edit_item'         => __( 'Edit Shortcode Category', 'escwp' ),
		'update_item'       => __( 'Update Shortcode Category', 'escwp' ),
		'add_new_item'      => __( 'Add New Shortcode Category', 'escwp' ),
		'new_item_name'     => __( 'New Shortcode Category', 'escwp' ),
		'menu_name'         => __( 'Shortcode Categories', 'escwp' ),
	);

	$args = array(
		'hierarchical'      => true,
		'labels'            => $labels,
		'show_ui'           => true,
		'show_admin_column' => true,
		'query_var'         => true,
		'rewrite'           => array( 'slug' => 'e-shortcode' ),
	);

	register_taxonomy( 'shortcodecategory', array( 'shortcode' ), $args );
}*/


/*-----------------------------------------------------------------------------------*/
/*	Show the shorcode and ID on Admin
/*-----------------------------------------------------------------------------------*/
function escwp_shortcode_id_meta_boxes(){
	add_meta_box('shortcode', __('Shortcode ID!', 'escwp'), 'escwp_shortcode_metabox', 'escwp-shortcode', 'side', 'core');
}

add_action( 'add_meta_boxes', 'escwp_shortcode_id_meta_boxes' );

function escwp_shortcode_metabox($post, $metabox){
	?>
		<code>[escwp-shortcode id=<?php print $post->ID ?>]</code>
		<small class="description"><?php _e('Get the Shortcode code to display the content on another page!', 'escwp') ?></small>
	<?php
}

/*-----------------------------------------------------------------------------------*/
/*	Create Custom Spaces for Custom Post Types on admin pages
/*-----------------------------------------------------------------------------------*/
//modify Shortcode admin page structure
add_filter( 'manage_edit-escwp-shortcode_columns', 'escwp_shortcode_edit_shortcode_columns' ) ;

function escwp_shortcode_edit_shortcode_columns( $columns ) {

	$columns = array(
		'cb' => '<input type="checkbox" />',
		'title' => __( 'Items', 'escwp' ),
		'shortcode' => __( 'Shortcode - Copy and Paste on Post/Page', 'escwp' ),
		'date' => __( 'Date', 'escwp' )
	);

	return $columns;
}


add_action( 'manage_escwp-shortcode_posts_custom_column', 'escwp_shortcode_manage_columns', 10, 2 );
function escwp_shortcode_manage_columns( $column, $post_id ) {
	global $post;

	switch( $column ) {
		case 'shortcode' :
			echo "<input type=text readonly=readonly value='[escwp-shortcode id={$post->ID}]' size=35 style='font-weight:bold;text-align:Center;' onclick='this.select()' />";
			break;

		default :
			break;
	}
}